<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="utf-8"/>

<xsl:variable name="service">
    services/katrin.php?target=file&amp;
</xsl:variable>

<xsl:template name="image">
    <xsl:variable name="link">
        <xsl:text>services/katrin.php?target=file&amp;</xsl:text>
        <xsl:if test="@run">run=<xsl:value-of select="@run" />&amp;</xsl:if>
        <xsl:text>filename=</xsl:text><xsl:value-of select="@filename" />
    </xsl:variable>

    <xsl:element name="a">
        <xsl:attribute name="href">
            <xsl:value-of select="$link" />
            <xsl:text>.png</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="target">_blank</xsl:attribute>
        <xsl:element name="img">
            <xsl:attribute name="src">
                <xsl:value-of select="$link" />
                <xsl:text>_pv.png</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="border">0</xsl:attribute>
            <xsl:attribute name="alt">
                <xsl:value-of select="." />
            </xsl:attribute>
        </xsl:element>
    </xsl:element>
</xsl:template>

<xsl:template match="file">
    <p>
        <xsl:element name="a">
            <xsl:attribute name="href">
                <xsl:text>services/katrin.php?target=file&amp;</xsl:text>
                <xsl:if test="@run">
                    <xsl:text>run=</xsl:text>
                    <xsl:value-of select="@run" /><xsl:text>&amp;</xsl:text>
                </xsl:if>
                <xsl:text>filename=</xsl:text>
                <xsl:value-of select="@filename" />
                <xsl:text>&amp;download=yes</xsl:text>
            </xsl:attribute>
            <xsl:value-of select="." />
        </xsl:element>
        <xsl:if test="@filesize">
            <xsl:text> (</xsl:text>
            <xsl:value-of select="@filesize" />
            <xsl:text>)</xsl:text>
        </xsl:if>
    </p>
</xsl:template>

<xsl:template match="plots">
    <h4><xsl:value-of select="@title" />:</h4>
    <div class="pics">
        <table>
            <tr>
                <xsl:for-each select="image">
                    <th><xsl:value-of select="." />:</th>
                </xsl:for-each>
            </tr>
            <tr>
                <xsl:for-each select="image">
                    <td><xsl:call-template name="image" /></td>
                </xsl:for-each>
            </tr>
        </table>
    </div>
    <p><xsl:apply-templates select="image" /></p>
</xsl:template>

<xsl:template match="downloads">
    <h4>Downloads</h4>
    <xsl:apply-templates select="file" />
</xsl:template>

<xsl:template match="parameters">
    <xsl:if test="magnet_west or magnet_east">
        <div class="mag">
            <xsl:if test="magnet_west">
                <b>West magnet: </b>
                <span class="fett">
                    <xsl:value-of select="magnet_west" />A (<xsl:value-of select="field_west" />T)
                </span>
            </xsl:if>
            <xsl:if test="magnet_east">
                <b>East magnet: </b>
                <span class="fett">
                    <xsl:value-of select="magnet_east" />A (<xsl:value-of select="field_east" />T)
                </span>
            </xsl:if>
        </div>
    </xsl:if>
    <xsl:if test="det_ps or ps_egun">
        <div class="val">
            <xsl:if test="det_ps">
                <b>Valve Det/PS: </b>
                <span class="fett">
                    <xsl:value-of select="det_ps" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="ps_egun">
                <b>Valve PS/egun: </b>
                <span class="fett">
                    <xsl:value-of select="ps_egun" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
        </div>
    </xsl:if>
    <xsl:if test="t or s1 or s2 or s3 or s4 or d1 or d2">
        <div class="ele">
            <xsl:if test="t">
                <b>T: </b>
                <span>
                    <xsl:value-of select="t" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="s1">
                <b>S1: </b>
                <span>
                    <xsl:value-of select="s1" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="s2">
                <b>S2: </b>
                <span>
                    <xsl:value-of select="s2" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="s3">
                <b>S3: </b>
                <span>
                    <xsl:value-of select="s3" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="s4">
                <b>S4: </b>
                <span>
                    <xsl:value-of select="s4" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="d1">
                <b>D1: </b>
                <span>
                    <xsl:value-of select="d1" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="d2">
                <b>D2: </b>
                <span>
                    <xsl:value-of select="d2" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
        </div>
    </xsl:if>
    <xsl:if test="fug1 or fug2 or fug3 or fug4 or fug5">
        <div class="ele">
            <xsl:if test="fug1">
                <b>FUG1: </b>
                <span class="fett"><xsl:value-of select="fug1" />kV </span>
            </xsl:if>
            <xsl:if test="fug2">
                <b>FUG2: </b>
                <span class="fett"><xsl:value-of select="fug2" />kV </span>
            </xsl:if>
            <xsl:if test="fug3">
                <b>FUG3: </b>
                <span class="fett"><xsl:value-of select="fug3" />kV </span>
            </xsl:if>
            <xsl:if test="fug4">
                <b>FUG4: </b>
                <span class="fett"><xsl:value-of select="fug4" />kV </span>
            </xsl:if>
            <xsl:if test="fug5">
                <b>FUG5: </b>
                <span class="fett"><xsl:value-of select="fug5" />kV </span>
            </xsl:if>
        </div>
    </xsl:if>
    <xsl:if test="pressure">
        <div class="ele">
            <b>Pressure: </b>
            <span class="fett"><xsl:value-of select="pressure" />mbar </span>
        </div>
    </xsl:if>
    <xsl:if test="egun_uv or egun_shutter or egun_hv or egun_x or egun_y">
        <div class="egu">
            <xsl:if test="egun_uv">
                <b>UV light: </b>
                <span class="fett">
                    <xsl:value-of select="egun_uv" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="egun_shutter">
                <b>Shutter: </b>
                <span class="fett">
                    <xsl:value-of select="egun_shutter" />
                    <xsl:text> </xsl:text>
                </span>
            </xsl:if>
            <xsl:if test="egun_hv">
                <b>Voltage: </b>
                <span class="fett"><xsl:value-of select="egun_hv" />kV </span>
            </xsl:if>
            <xsl:if test="egun_x">
                <b>X: </b>
                <span class="fett"><xsl:value-of select="egun_x" />° </span>
            </xsl:if>
            <xsl:if test="egun_y">
                <b>Y: </b>
                <span class="fett"><xsl:value-of select="egun_y" />° </span>
            </xsl:if>
        </div>
    </xsl:if>
</xsl:template>

<xsl:template match="run">
    <h3>Run <xsl:value-of select="identifier" /></h3>
     <div class="gen">
         <b>Date: </b>
         <span class="fett">
             <xsl:value-of select="date" />
             <xsl:text> </xsl:text>
         </span>
         <b>Run number: </b>
         <span class="fett">
             <xsl:value-of select="identifier" />
             <xsl:text> </xsl:text>
         </span>
         <b>Timestamp: </b>
         <span class="fett">
             <xsl:value-of select="start" /> - <xsl:value-of select="end" />
         </span>
     </div>
     <div class="det">
         <b>Detector: </b>
         <span class="fett">
             <xsl:value-of select="detector" />
             <xsl:text> </xsl:text>
         </span>
         <b>X: </b>
         <span class="fett"><xsl:value-of select="detector_x" />cm </span>
         <b>Y: </b>
         <span class="fett"><xsl:value-of select="detector_y" />cm </span>
         <b>Z: </b>
         <span class="fett"><xsl:value-of select="detector_z" />cm </span>
         <b>Crate: </b>
         <span class="fett"><xsl:value-of select="crate" /> </span>
     </div>
     <div class="det">
         <b>Configuration: </b>
         <span class="fett">
             <xsl:value-of select="configuration" />
             <xsl:text> </xsl:text>
         </span>
         <b>ORCA version: </b>
         <span class="fett"><xsl:value-of select="orca_version" /> </span>
     </div>
     <xsl:apply-templates select="parameters" />
     <xsl:apply-templates select="downloads" />
</xsl:template>

<xsl:template match="subrun">
    <h4>Subrun <xsl:value-of select="identifier" /></h4>
    <div class="gen">
        <b>Subrun number: </b>
        <span class="fett">
            <xsl:value-of select="identifier" />
            <xsl:text> </xsl:text>
        </span>
        <b>Timestamp: </b>
        <span class="fett">
            <xsl:value-of select="start" /> - <xsl:value-of select="end" />
        </span>
    </div>
    <xsl:apply-templates select="parameters" />
    <div class="cmt">
        <b>Comment:</b>
    </div>
    <div class="cmt">
        <span><xsl:value-of select="comment" /></span>
    </div>
    <xsl:apply-templates select="plots" />
</xsl:template>

<xsl:template match="/result">
    <style type="text/css">
        h1 {
        text-align: center;
        }
        b {
        font-weight: normal;
        }
        th {
        color:black;
        text-align: left;
        font-size: 105%;
        }
        p.intro {
        text-align: center;
        color: black;
        }
        .rundescription {
        border: 10px solid white;
        font-size: 105%;
        }
        div.gen {
        background-color: rgb(192,192,192);
        }
        div.det {
        background-color: rgb(255,255,153);
        }
        div.mag {
        background-color: rgb(204,255,204);
        }
        div.ele {
        background-color: rgb(255,204,153);
        }
        div.egu {
        background-color: rgb(153,204,255);
        }
        div.cmt {
        background-color: rgb(0,0,0);
        color:white; 
        }
        div.pics {
        background-color: white;
        }
        .fett {
        font-size: 100%;
        font-weight: bold;
        }
    </style>

    <div>
        <xsl:if test="Error">
            <span class="error"><xsl:value-of select="Error" /></span>
        </xsl:if>

        <xsl:if test="not(Error)">
            <xsl:apply-templates select="run" />
            <xsl:apply-templates select="subrun" />
        </xsl:if>	
    </div>
</xsl:template>
</xsl:stylesheet>
